/* 
* File: nvalsrnd.c
* By: Isaac Michaud and David Hiebeler
*     http://www.math.umaine.edu/~hiebeler
*
* This program demonstrates a problem with the random number 
* generator "random()"
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/time.h>


int main() {
  struct timeval tp;
  struct timezone *tzp;
  int i, iters=10000000, left=0, right=0;
  // int i,test;
  long int r;

  /* Use the current time in milliseconds to seed the random
   * number generator
   */
  tzp = NULL;
  gettimeofday(&tp, tzp);
  srandom((unsigned int) tp.tv_usec);

  for(i=0;i<iters;i++){
    random();  /* Note: without this extra call to random() in the loop, the problem does not arise */ 
    r = random();
    if (r < (1<<29)) {  /* compare to 1<<29, which is 0.25*1<<32, where
			 * 1<<32 (or more precisely 1<<32 - 1)is the maximum
			 * value the random number generator will produce */
      /* 25% of the time, we make one extra call to random() */
      random();
      left++;
    } else {
      /* the other 75% of the time, we make three extra calls to random() */
      random();
      random();
      random();
      right++;
    }
    if (i % 100000 == 0) {
      printf("Left: %d  Right: %d  R/L Ratio %f (should be 3)\n",left,right,(double)right/left);
    } 
  }  
  return 0;
}
